/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javafx.application.Application;
import static javafx.application.Application.launch;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.event.Event;
import javafx.event.EventHandler;
import javafx.scene.Scene;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.control.Button;
import javafx.scene.control.ColorPicker;
import javafx.scene.control.ComboBox;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.control.ToggleButton;
import javafx.scene.layout.HBox;
import javafx.scene.layout.StackPane;
import javafx.scene.layout.VBox;
import javafx.scene.paint.Color;
import javafx.stage.FileChooser;
import javafx.stage.Stage;
import static javafx.application.Application.launch;

public class EHDraw extends Application {

    static EvolutionTree strom = new EvolutionTree();
    static GraphicsContext gc;
    static Stage primaryStage;
    static boolean gui = true;// -nogui to turn off
    static boolean optimize = false; // -opt
    static boolean export_greedy = false; //-exportgreedy
    static boolean export_ilp = false; //-exportilp
    static boolean draw_svg = false; // -drawsvg
    static String input; //-input:input.history
    static String svg_output = "output.svg";
    static String ilp_output = "output.lp";
    static String greedy_output = "output.greedy";
    static String load_settings = null; //-settings:filename
    static String load_lp = null;
    static ComboBox pickGene ;
    static  Button removeMeta;
    static ComboBox drawC;
    static  ComboBox highlightedC;
    static ComboBox transparentC;
    static TextField lineWF;
    static TextField nameF;
    static ColorPicker colorP;
    static  Button useDefault;
    //static Settings s=new Settings();
    //Scanner in = new Scanner(System.in);
    @Override
    public void start(Stage _primaryStage) throws FileNotFoundException, IOException {
        primaryStage = _primaryStage;
       

            VBox controlsVBox = new VBox(10);
            VBox globalsVBox = new VBox();
            HBox root = new HBox(10);

            final Canvas cnv = new Canvas(Settings.width, Settings.height);
            StackPane cnvPane = new StackPane();
            cnvPane.getChildren().add(cnv);

            root.getChildren().add(controlsVBox);
            root.getChildren().add(cnvPane);
            root.getChildren().add(globalsVBox);
            Scene scene = new Scene(root, Settings.width + 400, Settings.height);
            primaryStage.setTitle(Settings.title);
            primaryStage.setScene(scene);
            primaryStage.show();
            gc = cnv.getGraphicsContext2D();

            Button openButton = new Button("Open");
            Button optimizeButton = new Button("Optimize");
            Button exportILPButton = new Button("Export ILP");
            Button importILPButton = new Button("Import ILP");
            Button saveIMGButton = new Button("Save Img");
            Button importSettingsButton = new Button("Import Settings");
            Button exportSettingsButton = new Button("Export Settings");
            Button redrawButton = new Button("Redraw");

            openButton.setOnAction(new OpenButtonHandler(primaryStage));
            optimizeButton.setOnAction(new OptimizeButtonHandler());
            saveIMGButton.setOnAction(new SaveImgButtonHandler());
            redrawButton.setOnAction(new redrawButtonHandler());
            importSettingsButton.setOnAction(new importSettingsButtonHandler());
            exportSettingsButton.setOnAction(new exportSettingsButtonHandler());
            exportILPButton.setOnAction(new exportILPButtonHandler());
            importILPButton.setOnAction(new importILPButtonHandler());
            

            ObservableList<javafx.scene.Node> controls = controlsVBox.getChildren();
            controls.add(openButton);
            controls.add(saveIMGButton);
            controls.add(importSettingsButton);
            controls.add(exportSettingsButton);
            controls.add(optimizeButton);
            controls.add(exportILPButton);
            controls.add(importILPButton);
            controls.add(redrawButton);

            Label timeDiffL = new Label("Time diff");
            final TextField timeDiffF = new TextField(Double.toString(Settings.time_diff));
            HBox timeDiffH = new HBox(10);
            timeDiffH.getChildren().addAll(timeDiffL, timeDiffF);
            timeDiffF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    if (validDouble(timeDiffF.getText())) {
                        Settings.time_diff = Double.parseDouble(timeDiffF.getText());
                        if (Settings.redraw) {
                            draw();
                        }
                    }
                }

            });

            Label widthL = new Label("Width");
            final TextField widthF = new TextField(Integer.toString(Settings.width));
            HBox widthH = new HBox(10);
            widthH.getChildren().addAll(widthL, widthF);
            widthF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    String s = widthF.getText();
                    if (validInteger(s)) {
                        Settings.width = Integer.parseInt(s);
                        cnv.setWidth(Settings.width);
                        strom.calcScale();
                        draw();
                    }
                }
            });

            Label heightL = new Label("Height");
            final TextField heightF = new TextField(Integer.toString(Settings.height));
            HBox heightH = new HBox(10);
            heightH.getChildren().addAll(heightL, heightF);
            heightF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    String s = heightF.getText();
                    if (validInteger(s)) {
                        Settings.height = Integer.parseInt(s);
                        cnv.setHeight(Settings.height);
                        draw();
                    }
                }
            });
            
            Label nodeGapL = new Label("Node Gap");
            final TextField nodeGapF = new TextField(Integer.toString(Settings.line_gap));
            HBox nodeGapH = new HBox(10);
            nodeGapH.getChildren().addAll(nodeGapL,nodeGapF);
            
            nodeGapF.setOnAction(new EventHandler() {
            @Override
            public void handle(Event event) {
                Settings.node_gap = Integer.parseInt(nodeGapF.getText());
                if(Settings.redraw){
                    draw();
                }
            }
        });
            Label lineGapL = new Label("Line Gap");
            final TextField lineGapF = new TextField(Integer.toString(Settings.line_gap));
            HBox lineGapH = new HBox(10);
            lineGapH.getChildren().addAll(lineGapL, lineGapF);
            lineGapF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    if (validInteger(lineGapF.getText())) {
                        Settings.line_gap = Integer.parseInt(lineGapF.getText());
                        if (Settings.redraw) {
                            draw();
                        }
                    }
                }
            });

            Label lineSizeL = new Label("Line Size");
            final TextField lineSizeF = new TextField(Integer.toString(Settings.line_size));
            HBox lineSizeH = new HBox(10);
            lineSizeH.getChildren().addAll(lineSizeL, lineSizeF);
            lineSizeF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    String s = lineSizeF.getText();
                    if (validInteger(s)) {
                        Settings.line_size = Integer.parseInt(s);
                        if (Settings.redraw) {
                            draw();
                        }
                    }
                }
            });

            Label satL = new Label("Saturation");
            final TextField satF = new TextField(Double.toString(Settings.saturation));
            HBox satH = new HBox(10);
            satH.getChildren().addAll(satL, satF);
            satF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    String s = satF.getText();
                    if (validDouble(s)) {
                        Settings.saturation = Double.parseDouble(s);
                        Settings.calcColors();
                        if (Settings.redraw) {
                            draw();
                        }
                    }
                }
            });

            Label briL = new Label("Brightness");
            final TextField briF = new TextField(Double.toString(Settings.brightness));
            HBox briH = new HBox(10);
            briH.getChildren().addAll(briL, briF);
            briF.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    String s = briF.getText();
                    if (validDouble(s)) {
                        Settings.brightness = Double.parseDouble(s);
                        Settings.calcColors();
                        if (Settings.redraw) {
                            draw();
                        }
                    }
                }
            });
            
            Label optL = new Label("Optimization");
            final TextField optF = new TextField(Integer.toString(Settings.optimized));
            HBox optH = new HBox(10);
            optH.getChildren().addAll(optL,optF);
            optF.setOnAction(new EventHandler(){
            @Override
            public void handle(Event event) {
                String s = optF.getText();
                Settings.optimized = Integer.parseInt(s);
                strom.optimize();
                if(Settings.redraw){
                    draw();
                }
            }
            
            });
            
            Label nonhighlightedL = new Label("Non highlighted");
            ColorPicker nonhighlightedP = new ColorPicker((Color) Settings.nonhighlighted);
            HBox nonhighlightedH = new HBox(10);
            nonhighlightedH.getChildren().addAll(nonhighlightedL,nonhighlightedP);
            nonhighlightedP.setOnAction(new EventHandler() {
            @Override
            public void handle(Event event) {
                Settings.nonhighlighted = nonhighlightedP.getValue();
                if(Settings.redraw){
                    draw();
                }
            }
        });
                    
            final ToggleButton redraw = new ToggleButton("Redraw");
            redraw.setSelected(Settings.redraw);
            redraw.setOnAction(new EventHandler() {

                @Override
                public void handle(Event event) {
                    Settings.redraw = redraw.isSelected();
                }
            });
            
            
            pickGene = new ComboBox();
            updateComboBox();
            pickGene.setOnAction(new EventHandler() {
            @Override
            public void handle(Event event) {
                if(pickGene.getValue()=="None"){
                    metaclear();
                }else if(pickGene.getValue()=="Default"){
                transparentC.setDisable(false);
                highlightedC.setDisable(false);
                drawC.setDisable(false);     
                }else{
                    removeMeta.setDisable(true);
                    colorP.setDisable(true);
                    nameF.setDisable(true);
                    lineWF.setDisable(true);
                    transparentC.setDisable(true);
                    highlightedC.setDisable(true);
                    drawC.setDisable(true);  
                }
                
            }
        });
            
            Label drawL = new Label("Draw");
             drawC = new ComboBox();
            HBox drawH = new HBox(10);
            drawH.getChildren().addAll(drawL,drawC);
            
            Label highlightedL = new Label("Highlighted");
             highlightedC = new ComboBox();
            HBox highlightedB = new HBox(10);
            highlightedB.getChildren().addAll(highlightedL,highlightedC);
            
            Label transparentL = new Label("Transparent");
             transparentC = new ComboBox();
            HBox transparentH = new HBox(10);
            transparentH.getChildren().addAll(transparentL,transparentC);
            
            Label lineWL = new Label("Line Width");
             lineWF = new TextField(Integer.toString(Settings.line_size));
            HBox lineWH = new HBox(10);
            lineWH.getChildren().addAll(lineWL,lineWF);
            
            Label nameL = new Label("Name");
             nameF = new TextField();
            HBox nameH = new HBox(10);
            nameH.getChildren().addAll(nameL,nameF);
            
            Label colourL = new Label("Colour");
             colorP = new ColorPicker();
            HBox colorH = new HBox(10);
            colorH.getChildren().addAll(colourL,colorP);
            
            removeMeta = new Button("Delete gene meta");
            removeMeta.setOnAction(new EventHandler() {
            @Override
            public void handle(Event event) {
               Settings.removeMeta((int) pickGene.getValue());
               metaclear();
            }
        });
            useDefault = new Button("Delete all meta");
            useDefault.setOnAction(new EventHandler() {
            @Override
            public void handle(Event event) {
               Settings.clearGeneMeta();
               metaclear();
            }
        });
            HBox metaButtonsH = new HBox(10);
            metaButtonsH.getChildren().addAll(removeMeta,useDefault);
            
            globalsVBox.getChildren().addAll(timeDiffH, widthH, heightH, nodeGapH, lineGapH, lineSizeH, satH, briH,optH, nonhighlightedH, redraw, pickGene, drawH, transparentH, highlightedB, lineWH, nameH, colorH, metaButtonsH);

        

    }
    private void metaclear(){
            pickGene.getItems().clear();
            pickGene.getItems().add("None");
            pickGene.getItems().addAll("Default");
            pickGene.getItems().addAll(strom.getGenes());
            pickGene.setValue("None");
            removeMeta.setDisable(true);
            colorP.setDisable(true);
            nameF.setDisable(true);
            lineWF.setDisable(true);
            transparentC.setDisable(true);
            highlightedC.setDisable(true);
            drawC.setDisable(true);            
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException {
        for (String s : args) {
            String[] splitted = s.split(":");
            switch (splitted[0]) {
                case"-load_settings":
                    load_settings=splitted[1];
                    break;
                case "-exportgreedy":
                    export_greedy = true;
                    break;
                case "-exportilp":
                    export_ilp = true;
                    break;
                case "-drawsvg":
                    draw_svg = true;
                    break;
                case "-input":
                    input = splitted[1];
                    break;
                case "-nogui":
                    gui = false;
                    break;
                case "-opt":
                    optimize = true;
                    Settings.optimized = Integer.parseInt(splitted[1]);
                    break;
                case "-greedy_output":
                    greedy_output = splitted[1];
                    break;
                case "-ilp_output":
                    ilp_output = splitted[1];
                    break;
                case "-svg_output":
                    svg_output = splitted[1];
                    break;
                case "-load_lp":
                    load_lp = splitted[1];
                    break;

            }
        }
        if(gui){
            launch(args);
        }else{
            File f = new File(input);
            strom.load(f);
            if (optimize) {
                strom.findBlocks();
            }
            if (export_greedy) {
                File file = new File(greedy_output);
                file.delete();
                file.createNewFile();
                FileWriter fw = new FileWriter(file.getAbsoluteFile());
                BufferedWriter bw = new BufferedWriter(fw);
                strom.exportBlocks(bw);
                fw.close();

            }
            if (export_ilp) {
                File file = new File(ilp_output);
                file.delete();
                file.createNewFile();
                FileWriter fw = new FileWriter(file.getAbsoluteFile());
                BufferedWriter bw = new BufferedWriter(fw);
                strom.exportILP(bw);
                fw.close();
            }
            if(load_settings!=null){
                Settings.loadXML(load_settings);
            }
            if(load_lp!=null){
                File lp= new File(load_lp);                    
                strom.loadILP(lp);
            }
            if (draw_svg) {
                DrawFactory drawF = new SVGDrawFactory();
                drawF.clear();
                strom.print(drawF);
                File file = new File(svg_output);
                file.delete();
                file.createNewFile();
                drawF.export(file);
            }
            System.exit(0);
        }
    }

    private static void draw() {
        DrawFactory drawF = new FXDrawFactory(gc);
        drawF.clear();
        strom.print(drawF);
    }

    private static boolean validDouble(String s) {
        return true;
    }

    private static boolean validInteger(String s) {
        return true;
    }

    private static class OpenButtonHandler implements EventHandler<ActionEvent> {

        private final Stage primaryStage;

        public OpenButtonHandler(Stage _primaryStage) {
            this.primaryStage = _primaryStage;
        }

        @Override
        public void handle(ActionEvent event) {
            FileChooser fileChooser = new FileChooser();
            FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("History file (*.history)", "*.history");
            fileChooser.getExtensionFilters().add(extFilter);
            File file = fileChooser.showOpenDialog(primaryStage);
            Settings.title = file.getName();
            primaryStage.setTitle(Settings.title);
            try {
                strom = new EvolutionTree();
                strom.load(file);
                draw();
            } catch (FileNotFoundException ex) {
                Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
            }
            updateComboBox();

        }

       
    }
     private static void updateComboBox() {
        }

    private static class SaveImgButtonHandler implements EventHandler<ActionEvent> {

        public SaveImgButtonHandler() {

        }

        @Override
        public void handle(ActionEvent event) {
            /**
             * DrawFactory drawF = new SVGDrawFactory(); strom.print(drawF);
             * drawF.export();
             *
             */
            FileChooser fileChooser1 = new FileChooser();
            fileChooser1.setTitle("Save Image");
            FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("SVG files (*.svg)", "*.svg");
            fileChooser1.getExtensionFilters().add(extFilter);
            File file = fileChooser1.showSaveDialog(primaryStage);

            DrawFactory drawF = new SVGDrawFactory();
            strom.print(drawF);
            drawF.export(file);
        }
    }

    private static class redrawButtonHandler implements EventHandler<ActionEvent> {

        public redrawButtonHandler() {

        }

        @Override
        public void handle(ActionEvent event) {
            draw();
        }
    }

    private static class importSettingsButtonHandler implements EventHandler<ActionEvent> {

        public importSettingsButtonHandler() {
        }

        @Override
        public void handle(ActionEvent event) {
            FileChooser fileChooser = new FileChooser();
            FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("xml files (*.xml)", "*.xml");
            fileChooser.getExtensionFilters().add(extFilter);
            File file = fileChooser.showOpenDialog(primaryStage);
            Settings.loadXML(file);
            if (Settings.redraw) {
                draw();
            }

        }
    }

    private static class exportSettingsButtonHandler implements EventHandler<ActionEvent> {

        public exportSettingsButtonHandler() {

        }

        @Override
        public void handle(ActionEvent event) {
            FileChooser fileChooser1 = new FileChooser();
            fileChooser1.setTitle("Export Settings");
            FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("xml files (*.xml)", "*.xml");
            fileChooser1.getExtensionFilters().add(extFilter);
            File file = fileChooser1.showSaveDialog(primaryStage);
            file.delete();
            try {
                file.createNewFile();
            } catch (IOException ex) {
                Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
            }
            Settings.exportXML(file);

        }
    }

    private static class OptimizeButtonHandler implements EventHandler<ActionEvent> {

        public OptimizeButtonHandler() {
        
        }

        @Override
        public void handle(ActionEvent event) {
            strom.optimize();
            if (Settings.redraw) {
                draw();
            }
        }
    }

    private static class exportILPButtonHandler implements EventHandler<ActionEvent> {
            
        public exportILPButtonHandler() {
            
        }

        @Override
        public void handle(ActionEvent event) {
            try {
                FileChooser fileChooser1 = new FileChooser();
                fileChooser1.setTitle("Export ILP");
                FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("ILP files (*.lp)", "*.lp");
                fileChooser1.getExtensionFilters().add(extFilter);
                File file = fileChooser1.showSaveDialog(primaryStage);
                file.delete();
                file.createNewFile();
                FileWriter fw = null;
                try {
                    fw = new FileWriter(file);
                } catch (IOException ex) {
                    Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
                }
                BufferedWriter bw = new BufferedWriter(fw);
                try {
                    strom.exportILP(bw);
                    fw.close();
                } catch (IOException ex) {
                    Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
                }
            } catch (IOException ex) {
                Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }

    private static class importILPButtonHandler implements EventHandler<ActionEvent> {

        public importILPButtonHandler() {
        }

        @Override
        public void handle(ActionEvent event) {
            FileChooser fileChooser = new FileChooser();
            FileChooser.ExtensionFilter extFilter = new FileChooser.ExtensionFilter("Solution files (*.sol)", "*.sol");
            fileChooser.getExtensionFilters().add(extFilter);
            File file = fileChooser.showOpenDialog(primaryStage);
            try {
                strom.loadILP(file);
            } catch (FileNotFoundException ex) {
                Logger.getLogger(EHDraw.class.getName()).log(Level.SEVERE, null, ex);
            }
            if (Settings.redraw) {
                draw();
            }
        }
    }

}
